<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:dp="http://www.datapower.com/extensions"
  extension-element-prefixes="dp"
>
  <dp:input-mapping  href="store:///pkcs7-convert-input.ffd" type="ffd"/>
  <dp:output-mapping href="store:///pkcs7-convert-input.ffd" type="ffd"/>

    
  <xsl:variable name="input64"
    select="dp:binary-encode(/object/message/node())"
  />
  <xsl:variable name="start" select="dp:encode('&lt;wrap>','base-64')"/>
  <xsl:variable name="end"   select="dp:encode('&lt;/wrap>','base-64')"/>

  <xsl:variable name="out64">
    <xsl:choose>
      <xsl:when test="dp:variable('var://context/wrap/doit')">
        <xsl:value-of select="dp:concat-base64(
                               dp:concat-base64($start, $input64),
                               $end
                              )"
        />
      </xsl:when>
      <xsl:otherwise><xsl:value-of select="$input64"/></xsl:otherwise>
    </xsl:choose>
  </xsl:variable>

  <xsl:template match="/">
    <object>
      <message>
        <xsl:value-of select="dp:binary-decode($out64)" />
      </message>
    </object>
  </xsl:template>
  
</xsl:stylesheet>
